<template>
  <SfModal class="sw-gs-fullscreen-modal"
           :visible="isFullscreenVideoModalOpen"
           :overlay="false"
           :cross="false"
           :persistent="true">
    <div class="sw-gs-fullscreen-modal-videos-wrapper">

      <div class="sw-gs-fullscreen-modal-active-speaker-wrapper">
        <div class="sw-gs-active-speaker-video-wrapper">
          <template v-if="activeSpeakerStream">
            <video :srcObject.prop="activeSpeakerStream" autoPlay muted playsInline></video>
          </template>

          <div v-else class="sw-gs-active-speaker-placeholder">
            <SwGsIconClient class="color-dark-secondary size-xxl"></SwGsIconClient>
          </div>

          <div class="sw-gs-active-speaker-name">
            <template v-if="activeSpeaker">
              <span v-if="activeSpeaker.data.user_name">{{ activeSpeaker.data.user_name }}</span>
              <span v-else>{{ $t('Anonymous') }}</span>
            </template>
          </div>
        </div>
      </div>

      <div v-if="hasMembers" class="sw-gs-fullscreen-modal-participants-slider-wrapper">
        <div ref="glideRef" class="glide sw-gs-participants-slider" :class="memberCount === 1 ? 'single-slide' : ''">
          <div class="glide__track" data-glide-el="track">
            <ul class="glide__slides">

              <li v-for="participant in memberParticipants"
                  class="glide__slide"
                  :key="'slide-' + participant.data.session_id">
                <div class="glide__slide-content">
                  <div class="sw-gs-participant-video-wrapper">
                    <video v-if="participant.data.video"
                           :key="`${participant.data.session_id}-video`"
                           :srcObject.prop="participant.streams.video"
                           autoPlay
                           muted

                           playsInline></video>
                    <div v-else class="sw-gs-participant-video-placeholder">
                      <SwGsIconClient class="color-dark-secondary size-xxl"></SwGsIconClient>
                    </div>
                  </div>
                  <div class="sw-gs-participants-info-wrapper">
                    <div class="sw-gs-participant-name">
                      <span v-if="participant.data.user_name">{{ participant.data.user_name }}</span>
                      <span v-else>{{ $t('Anonymous') }}</span>
                    </div>
                  </div>
                </div>
              </li>
            </ul>
          </div>

          <div class="glide__arrows sw-gs-participants-slider-controls" data-glide-el="controls">
            <SwButton class="glide__arrow-prev color-light is-circle" data-glide-dir="<">
              <SwGsIconLongArrowLeft class="dark-secondary size-sm"/>
            </SwButton>

            <SwButton class="glide__arrow-next color-light is-circle" data-glide-dir=">">
              <SwGsIconLongArrowRight class="dark-secondary size-sm"/>
            </SwButton>
          </div>
        </div>
      </div>

    </div>
  </SfModal>
</template>

<script>
  import { ref, watch } from '@vue/composition-api';
  import { useUIState, useSharedState } from "@shopware-pwa/composables";

  import SwButton from "@/components/atoms/SwButton.vue";
  import { SfModal } from "@storefront-ui/vue";
  import { SwGsIconClient, SwGsIconLongArrowLeft, SwGsIconLongArrowRight } from "../icons";

  import Glide from "@glidejs/glide";
  import { Controls } from '@glidejs/glide/dist/glide.modular.esm';
  import { debounce } from "lodash";
  import {useClearBodyScrollLock} from "../../logic/composables/useClearBodyScrollLock";
  import {useWatchers} from "../../logic/composables/useWatchers";

  const SLIDER_DEBOUNCE_TIME = 300;

  export default {
    name: "SwGsFullScreenVideoModal",
    components: {
      SfModal,
      SwGsIconClient,
      SwGsIconLongArrowLeft,
      SwGsIconLongArrowRight,
      SwButton
    },
    props: {
      sliderOptions: {
        type: Object,
        default() {
          return {
            type: "slider",
            rewind: false,
            perView: 4,
            gap: 15,
          };
        },
      },
      callData: {
        type: Object,
      }
    },
    setup(props) {

      const { isOpen: isFullscreenVideoModalOpen, switchState: toggleFullscreenVideoModal } = useUIState({ stateName: "GS_VIDEO_FULLSCREEN_MODAL_STATE" });

      useClearBodyScrollLock();

      const context = 'sw-gs-fullscreen-video-glide';
      const { sharedRef } = useSharedState();
      const { addWatcher } = useWatchers();
      const glide = ref(null);
      const _watchersStarted = sharedRef(`${context}-watchersStarted`, false);
      const _sliderIndex = sharedRef(`${context}-sliderIndex`, 0);
      const glideRef = ref();
      const _memberCount = ref(0);

      const reinitializeSlider = debounce(() => {
        destroySlider();
        setTimeout(initSlider, SLIDER_DEBOUNCE_TIME * 2);
      }, SLIDER_DEBOUNCE_TIME);

      const createSlider = () => {
        glide.value = new Glide(glideRef.value, props.sliderOptions);
        glide.value.mount({ Controls });
        glide.value.go(`=${_sliderIndex.value}`);
      };

      const destroySlider = () => {
        const glider = glide.value;
        if (glider !== null) {
          _sliderIndex.value = glider.index;
          glider.destroy();
          glide.value = null;
        }
      };

      const initSlider = () => {
        destroySlider();
        setCurrentMemberCount();
        if (_memberCount.value === 0) return props.callData.toggleFullscreenVideoModal(false);
        createSlider();
      };

      const setCurrentMemberCount = () => {
        _memberCount.value = props.callData.memberCount.value;
      };

      const closeModal = () => {
        destroySlider();
        props.callData.toggleFullscreenVideoModal(false);
      };

      const startWatchers = () => {
        if (_watchersStarted.value) return;
        _watchersStarted.value = true;
        addWatcher(watch(props.callData.memberCount, (count) => {
          if (count === 0) return closeModal();
          if (_memberCount.value !== count) {
            setCurrentMemberCount();
            reinitializeSlider();
          }
        }));
      };

      startWatchers();

      return {
        ...props.callData,
        isFullscreenVideoModalOpen,
        toggleFullscreenVideoModal,
        glide,
        glideRef,
        initSlider,
        destroySlider,
      }
    },
    mounted() {
      this.$nextTick(this.initSlider);
    },
    beforeDestroy() {
      if (this.glide) this.destroySlider();
    }
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";
  @import "../../assets/scss/mixins/mediaQueries";

  $participantVideoWidth: 175px;
  $participantVideoHeight: $participantVideoWidth * 0.56;
  $participantVideoHeightMobile: $participantVideoWidth * 0.75;
  $activeSpeakerVideoWidth: 750px;
  $activeSpeakerVideoHeight: $activeSpeakerVideoWidth * 0.56;
  $activeSpeakerVideoHeightMobile: $activeSpeakerVideoWidth * 0.75;
  $activeSpeakerVideoWidthMinimized: 150px;
  $activeSpeakerVideoHeightMinimized: $activeSpeakerVideoWidthMinimized * 0.56;
  $activeSpeakerVideoHeightMobileMinimized: $activeSpeakerVideoWidthMinimized * 0.75;

  .sw-gs-fullscreen-modal {

    ::v-deep .sf-modal__container {
      width: calc(100% - var(--sidebar-width));
      height: 100%;
      left: 0;
      top: 0;
      transform: none;
      max-height: none;
      transition: width 0.3s ease-in-out;;
    }

    ::v-deep .sf-modal__content {
      height: 100%;
    }

    .sw-gs-fullscreen-modal-videos-wrapper {
      display: flex;
      flex-direction: column;
      height: 100%;

      .sw-gs-fullscreen-modal-active-speaker-wrapper {
        height: 80%;
        width: 100%;
        position: relative;

        .sw-gs-active-speaker-video-wrapper {
          width: $activeSpeakerVideoWidth;
          height: $activeSpeakerVideoHeightMobile;
          overflow: hidden;
          background-color: var(--c-gray-variant);
          position: absolute;
          left: 50%;
          top: 50%;
          border-radius: 10px;
          transform: translate(-50%, -50%);
          box-shadow: 0 0 38px 0 rgba(0, 0, 0, 38%);

          @include for-desktop-small {
            height: $activeSpeakerVideoHeight;
          }

          video {
            height: 100%;
            width: 100%;
            object-fit: cover;
            display: block;
          }

          .sw-gs-active-speaker-placeholder {
            position: absolute;
            top: 50%;
            left: 50%;
            transform: translate(-50%, -50%);
          }

          .sw-gs-active-speaker-name {
            position: absolute;
            width: 100%;
            bottom: 0;
            left: 0;
            background: rgba(0, 0, 0, 0.5);
            color: var(--c-white);

            span {
              padding: 0 10px;
            }
          }
        }
      }

      .sw-gs-fullscreen-modal-participants-slider-wrapper {
        height: 20%;
        width: 100%;

        .glide {
          padding: 0 50px;

          &.single-slide {
            padding: 0 20px;

            .glide__arrows {
              display: none;
            }
          }

          .glide__slides {
            .glide__slide {
              .sw-gs-participant-video-wrapper {
                border-radius: 10px;
                overflow: hidden;
                display: flex;
                height: $participantVideoHeightMobile;
                width: $participantVideoWidth;

                @include for-desktop-small {
                  height: $participantVideoHeight;
                }

                .sw-gs-participant-video-placeholder {
                  width: 100%;
                  position: relative;
                  background-color: var(--c-gray-variant);

                  .sw-gs-icon {
                    position: absolute;
                    top: 50%;
                    left: 50%;
                    transform: translate(-50%, -50%);
                  }
                }

                video {
                  height: 100%;
                  width: 100%;
                  object-fit: cover;
                  display: block;
                }
              }
            }
          }

          .glide__arrows {
            position: absolute;
            top: 50%;
            left: 50%;
            width: 100%;
            transform: translate(-50%, -50%);

            .glide__arrow-prev,
            .glide__arrow-next {
              position: absolute;
              top: 50%;
              transform: translateY(-50%);
            }

            .glide__arrow-prev {
              left: 0;
            }

            .glide__arrow-next {
              right: 0;
            }
          }
        }
      }
    }
  }

</style>
